org.apache.felix.bundleplugin

## Class ManifestPlugin

- java.lang.Object
- - org.apache.maven.plugin.AbstractMojo
  - - org.apache.felix.bundleplugin.BundlePlugin
    - - org.apache.felix.bundleplugin.ManifestPlugin

- All Implemented Interfaces:
    org.apache.maven.plugin.ContextEnabled, org.apache.maven.plugin.Mojo
  Direct Known Subclasses:
    BundleAllPlugin

      @Mojo(name="manifest",
            requiresDependencyResolution=TEST,
            threadSafe=true,
            defaultPhase=PROCESS_CLASSES)
      public class ManifestPlugin
      extends BundlePlugin

  Generate an OSGi manifest for this project

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected boolean` | `rebuildBundle` When true, generate the manifest by rebuilding the full bundle in memory

    - ### Fields inherited from class org.apache.felix.bundleplugin.BundlePlugin

      `classifier, dumpClasspath, dumpInstructions, excludeDependencies, manifestLocation, niceManifest, packaging, supportedProjectTypes, unpackBundle`

    - ### Fields inherited from interface org.apache.maven.plugin.Mojo

      `ROLE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ManifestPlugin()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static String` | `calculateExportsFromContents(aQute.bnd.osgi.Jar bundle)`
    `protected void` | `execute(org.apache.maven.project.MavenProject project, Map<String,String> instructions, Properties properties, aQute.bnd.osgi.Jar[] classpath)`
    `protected aQute.bnd.osgi.Analyzer` | `getAnalyzer(org.apache.maven.project.MavenProject project, aQute.bnd.osgi.Jar[] classpath)`
    `protected aQute.bnd.osgi.Analyzer` | `getAnalyzer(org.apache.maven.project.MavenProject project, Map<String,String> instructions, Properties properties, aQute.bnd.osgi.Jar[] classpath)`
    `Manifest` | `getManifest(org.apache.maven.project.MavenProject project, aQute.bnd.osgi.Jar[] classpath)`
    `Manifest` | `getManifest(org.apache.maven.project.MavenProject project, Map<String,String> instructions, Properties properties, aQute.bnd.osgi.Jar[] classpath)`
    `static void` | `writeManifest(Manifest manifest, File outputFile, boolean niceManifest)`

    - ### Methods inherited from class org.apache.felix.bundleplugin.BundlePlugin

      `addMavenInstructions, addMavenSourcePath, buildOSGiBundle, convertVersionToOsgi, dumpClasspath, dumpInstructions, dumpManifest, execute, execute, getBase, getBuildDirectory, getBundleName, getClasspath, getDefaultProperties, getEmbeddableArtifacts, getFile, getMaven2OsgiConverter, getMavenResourcePaths, getOptionalPackages, getOSGiBuilder, getOutputDirectory, getProject, includeMavenResources, isTransitivelyOptional, mergeMavenManifest, removeTagFromInstruction, reportErrors, sanitize, sanitize, setBuildDirectory, setMaven2OsgiConverter, setOutputDirectory, transformDirectives`

    - ### Methods inherited from class org.apache.maven.plugin.AbstractMojo

      `getLog, getPluginContext, setLog, setPluginContext`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### rebuildBundle

          @Parameter(property="rebuildBundle")
          protected boolean rebuildBundle

      When true, generate the manifest by rebuilding the full bundle in memory

  - ### Constructor Detail

    - #### ManifestPlugin

          public ManifestPlugin()

  - ### Method Detail

    - #### execute

          protected void execute(org.apache.maven.project.MavenProject project,
                     Map<String,String> instructions,
                     Properties properties,
                     aQute.bnd.osgi.Jar[] classpath)
                          throws org.apache.maven.plugin.MojoExecutionException

      Overrides:
        `execute` in class `BundlePlugin`
      Throws:
        `org.apache.maven.plugin.MojoExecutionException`

    - #### getManifest

          public Manifest getManifest(org.apache.maven.project.MavenProject project,
                             aQute.bnd.osgi.Jar[] classpath)
                               throws IOException,
                                      org.apache.maven.plugin.MojoFailureException,
                                      org.apache.maven.plugin.MojoExecutionException,
                                      Exception

      Throws:
        `IOException`
        `org.apache.maven.plugin.MojoFailureException`
        `org.apache.maven.plugin.MojoExecutionException`
        `Exception`

    - #### getManifest

          public Manifest getManifest(org.apache.maven.project.MavenProject project,
                             Map<String,String> instructions,
                             Properties properties,
                             aQute.bnd.osgi.Jar[] classpath)
                               throws IOException,
                                      org.apache.maven.plugin.MojoFailureException,
                                      org.apache.maven.plugin.MojoExecutionException,
                                      Exception

      Throws:
        `IOException`
        `org.apache.maven.plugin.MojoFailureException`
        `org.apache.maven.plugin.MojoExecutionException`
        `Exception`

    - #### getAnalyzer

          protected aQute.bnd.osgi.Analyzer getAnalyzer(org.apache.maven.project.MavenProject project,
                                            aQute.bnd.osgi.Jar[] classpath)
                                                 throws IOException,
                                                        org.apache.maven.plugin.MojoExecutionException,
                                                        Exception

      Throws:
        `IOException`
        `org.apache.maven.plugin.MojoExecutionException`
        `Exception`

    - #### getAnalyzer

          protected aQute.bnd.osgi.Analyzer getAnalyzer(org.apache.maven.project.MavenProject project,
                                            Map<String,String> instructions,
                                            Properties properties,
                                            aQute.bnd.osgi.Jar[] classpath)
                                                 throws IOException,
                                                        org.apache.maven.plugin.MojoExecutionException,
                                                        Exception

      Throws:
        `IOException`
        `org.apache.maven.plugin.MojoExecutionException`
        `Exception`

    - #### writeManifest

          public static void writeManifest(Manifest manifest,
                           File outputFile,
                           boolean niceManifest)
                                    throws IOException

      Throws:
        `IOException`

    - #### calculateExportsFromContents

          public static String calculateExportsFromContents(aQute.bnd.osgi.Jar bundle)

Copyright © 2015. All rights reserved.